//
//  KinectManager.h
//  Kinect
//
//  IMPORTANT: REMEMBER TO CHANGE YOUR MASTER DEVICE LIST AFTER BUILDING THIS BUNDLE
 
/* MUST BE INCLUDED IN ALL TEMPLATES */
#import <Cocoa/Cocoa.h>
#import <DeviceServer/DeviceServer.h>
#import <DeviceServer/Device.h>
#import <DeviceServer/DeviceManager.h>
#import <DeviceServer/ApplicationManager.h>
#import <DeviceServer/OSCManager.h>

#include "XnOpenNI.h"
#include "XnVSessionManager.h"
#include "XnVMultiProcessFlowClient.h"
#include "XnVSwipeDetector.h"

#import "ColorView.h"

/* END MUST INCLUDES */

@interface KinectManager : NSObject {
	IBOutlet ColorView *view;
	IBOutlet NSButton *trackingButton;
	
	DeviceServer *ds;
	
	int count;
	
	IBOutlet NSTextField *trackingLabel;
	
	xn::Context context;
    XnVSessionGenerator* pSessionGenerator;
}

- (NSString *) name;
- (NSView *) view;
- (BOOL) shouldDisplayInterface;
- (IBAction) KinectConnect:(id)sender;

/* Below method should be removed or modified */
- (void) exampleCallback:(NSTimer *)timer;
- (void) sendValue:(float)value fromControlWithID:(int)controlID;
- (void) toggleTrackingButton:(BOOL)on;
- (void) createDeviceWithName:(NSString *)name;
@end
